<template>
  <b-row>
    <b-col cols="12" xl="6">
      <transition name="slide">
        <b-card>
          <div slot="header" v-html="caption"></div>
          <el-form :inline="true" :model="formInline" class="demo-form-inline">
            <el-form-item label="Name">
              <el-input v-model="tblParams.name" placeholder="Search by name"></el-input>
            </el-form-item>
            <el-form-item label="Code">
              <el-input v-model="tblParams.code" placeholder="Search by code"></el-input>
            </el-form-item>
            <el-form-item>
              <el-button type="primary" @click="refreshData">Search</el-button>
              <el-button type="default" @click="clearData">Clear</el-button>
            </el-form-item>
          </el-form>
          <el-row class="text-left">
            <el-button @click="()=>addCategory()">Add</el-button>
          </el-row>
          <el-table :data="categories" @row-dblclick="rowDblclick" border style="width: 100%">
            <el-table-column fixed type="index" width="40" label="#">
              <template
                slot-scope="scope"
              >{{(tblParams.currentPage - 1) * tblParams.perPage + (scope.$index + 1)}}</template>
              <!-- <template slot-scope="scope">{{getIndexRow(scope.$index)}}</template> -->
            </el-table-column>
            <el-table-column fixed prop="code" label="Category CODE" width="150"></el-table-column>
            <el-table-column prop="name" label="Name"></el-table-column>
            <el-table-column prop="description" label="Description"></el-table-column>
            <el-table-column fixed="right" label="Operations" width="120">
              <template slot-scope="scope">
                <el-button @click="rowClicked(scope.$index)" type="text" size="small">Edit</el-button>
                <el-button
                  @click.native.prevent="deleteCategory(scope.$index)"
                  type="text"
                  size="small"
                >Remove</el-button>
              </template>
            </el-table-column>
          </el-table>
          <b-pagination
            size="md"
            :total-rows="tblParams.totalRows"
            v-model="tblParams.currentPage"
            :per-page="tblParams.perPage"
          ></b-pagination>
        </b-card>
      </transition>
    </b-col>
  </b-row>
</template>

<script>
import { mapGetters } from "vuex"
import { CATEGORY_LIST_PAGE, CATEGORY_DELETE } from "../../store/actions.type"
import { SET_CATEGORY, SET_CATEGORIES } from "../../store/mutations.type"

export default {
  name: "CategoriesList",
  data() {
    return {
      caption: "Categories",
      tblParams: {
        name: '',
        code: '',
        currentPage: 1,
        perPage: 4,
        totalRows: 0,
      }
    }
  },
  computed: {
    ...mapGetters(['categories']),
    getIndexRow: function (index) {
      let rowIndex = (this.tblParams.currentPage - 1) * this.tblParams.perPage + (index + 1)
      return rowIndex
    }

  },
  mounted() {
    this.fetchCategoriesList(this.tblParams)
  },
  methods: {
    async fetchCategoriesList(params) {
      this.tblParams.totalRows = await this.$store.dispatch(CATEGORY_LIST_PAGE, params)
      console.log(this.tblParams.totalRows)
    },
    setSelectedCategory(category) {
      this.$store.commit(SET_CATEGORY, category)
    },
    rowDblclick(row, col, evt) {
      this.$router.push({ path: `category/${row.id}` })
    },
    rowClicked(index) {
      let selectedCategory = this.categories[index]

      this.$router.push({ path: `category/${selectedCategory.id}` })
      // this.$router.push({ path: "category/" + item.id })
    },
    getRowCount() {
      return this.categories.length
    },
    refreshData() {
      this.fetchCategoriesList(this.tblParams)
    },
    clearData() {
      this.tblParams = {
        name: '',
        code: '',
        currentPage: 1,
        perPage: 4,
        totalRows: 0,
      }
      this.refreshData()
    },
    addCategory() {
      this.$router.push({ path: `category/` })
    },
    deleteCategory(index) {
      var item = this.categories[index]
      var code = item.code
      var content = `This will permanently delete the category with name ${code}. Continue?`
      this.$confirm(content, "Warning", {
        confirmButtonText: "OK",
        cancelButtonText: "Cancel",
        type: "warning"
      })
        .then(() => {
          this.$store.dispatch(CATEGORY_DELETE, item)
        })
        .catch(() => {
          this.$message({
            type: "info",
            message: "Delete canceled"
          })
        })
    }
  },
  watch: {
    'tblParams.currentPage': function (newVal, oldVal) {
      this.fetchCategoriesList(this.tblParams)
    }
  }
}
</script>
<style scoped>
.card-body >>> table > tbody > tr > td {
  cursor: pointer;
}
.el-table >>> table > tbody > tr {
  cursor: pointer;
}
</style>
